class AccessCode {
  final int? id;
  final String code;
  final String scope;
  final int? userId;

  AccessCode({this.id, required this.code, required this.scope, this.userId});

  factory AccessCode.fromMap(Map map) => AccessCode(
        id: map['id'] as int,
        code: map['code'] as String,
        scope: map['scope'] as String,
        userId: map['user_id'],
      );

  Map<String, dynamic> get toMap => {
        'id': id,
        ...toMapShort,
        'user_id': userId,
      };

  Map<String, dynamic> get toMapShort => {
        'code': code,
        'scope': scope,
      };

  @override
  String toString() => '[AccessCode $toMap]';
}
