class AuthRequest {
  String username;
  String password;

  String grantType;
  List<Scope> scopes;

  AuthRequest({
    required this.username,
    required this.password,
    this.grantType = 'password',
    this.scopes = const [Scope.admin],
  });

  String get scopeString => scopes.map((e) => e.toString().split('.').last).join(' ');

  Map<String, dynamic> get toMap => <String, dynamic>{
        'username': username,
        'grant_type': grantType,
        'scopes': scopes,
      };

  @override
  String toString() => '[AuthRequest $scopeString $toMap]';
}

enum Scope {
  admin,
  user,
}
