import 'dart:convert';

class RuntimeSetting {
  RuntimeType type;
  Duration? duration;
  int? months;

  RuntimeSetting(this.type, {this.duration, this.months});

  factory RuntimeSetting.fromMap(Map map) => RuntimeSetting(
        runtimeTypeNames[map['type']],
        duration: map['duration'] != null ? Duration(hours: map['duration']) : null,
        months: map['months'],
      );

  Map get toMap => {
        'type': type.name.split('.').last,
        'duration': duration?.inHours,
        'months': months,
      };

  @override
  String toString() => json.encode(toMap);
}

enum RuntimeType {
  duration,
  nextSemester,
  months,
}

const Map runtimeTypeNames = {
  'duration': RuntimeType.duration,
  'months': RuntimeType.months,
  'nextSemester': RuntimeType.nextSemester,
};